/*************************************************************************
    Copyright (C) 2002,2003,2004,2005 Wei Qin
    See file COPYING for more information.

    This program is free software; you can redistribute it and/or modify    
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
*************************************************************************/

#ifndef __DECODE_H__
#define __DECODE_H__

#include "syscall.h"
#include "dpi.h"
#include "syscall.h"
#include "branch.h"
#include "mult.h"
#include "ldst.h"
#include "statreg.h"
#include "nwfpe.h"
#include "coproc.h"
#include <cstdio>

char *disasm_default(arm_inst_t inst, arm_addr_t pc, char *buf);
char *arm_disassemble(arm_inst_t inst, arm_addr_t pc, char *buf);
char *arm_disassemble(arm_inst_t inst, arm_addr_t pc, char *buf);
void arm_disassemble_to_stream(arm_inst_t inst, arm_addr_t pc, FILE *stream);

#if 0
extern void (*impl_table[256])(arm_inst_t);
extern char *(*disasm_table[256])(arm_inst_t, arm_addr_t, char *);

extern void (*impl_table_32[128])(arm_inst_t);
extern char *(*disasm_table_32[128])(arm_inst_t, arm_addr_t, char *);
#endif

#endif
